.686p
.model  flat, stdcall
option  casemap :none   ; case sensitive
.xmm
.nolist
include windows.inc
inv equ Invoke

MaxTests    equ 99          ; maximum number of timing tests, increase as desired up to 999
;PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
PriClass textequ <NORMAL_PRIORITY_CLASS>   ; for debugging


soff Macro QuotedText:Vararg    ; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

Desc Macro TextVal:Req  ; used in the first line of each test proc (Doit1....Doitxx)
local DescLoc, FirstFlag

.data
FirstFlag dd 0
DescLoc db TextVal,0
.code
    .if FirstFlag==0    ; if not first time, just continue
        mov FirstFlag,1 ; set done for next time
        mov ebx,offset DescLoc
        call SetDesc
        ret     ; if this was the first time, just return without running rest of code
    .endif
endm

.data?
align 16
hWin          dd ?  ; dialog handle
hEdit         dd ?
StartingCycle dd ?
CyclePart2    dd ?
Loops         dd ?
Min           dd ?
hHeap		  dd ?
Ans1		  dd ?
Ans2		  dd ?
.data
DoingOverhead dd 1	; very first pass will be overhead pass
overhead real8 0.0	; overhead of doing an empty test
pcfreq  dq 0
precnt  dq 0
pccount dq 0
counts  dd 0
pcanswr dq 0
t1000   dq 1000
ms dd 0
pcreal real8 0.0
.code

BeginCounter macro  ; This macro is inserted before a block of test code
    align 16    ; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, PriClass  ; use the highest priority for all the tests
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
    xor eax,eax
    cpuid       ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
	inv QueryPerformanceCounter,addr precnt
    ;rdtsc
    ;mov [StartingCycle],eax
    ;mov [StartingCycle+4],edx
endm
EndCounter macro        ; This macro is inserted after each block of test code
    xor eax,eax
    cpuid       ; flush
    ;rdtsc
    ;sub eax,[StartingCycle] ; get result in EDX:EAX
    ;sbb edx,[StartingCycle+4]
    ;mov Min,eax
    ;mov Ans1,eax
    ;mov Ans2,edx
    inv QueryPerformanceCounter,addr pccount
    inv QueryPerformanceFrequency, ADDR pcfreq
    finit
    fild pccount
    fild precnt
    fsub
	fwait
	.if DoingOverhead
		fst overhead
	.endif
	fsub overhead
	fist counts
    fild pcfreq
    fdiv
    fild t1000
    fmul
    fst pcreal
    fistp pcanswr
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS ; back to normal
    inv Sleep,0 

;    invoke wsprintf,addr buff,soff("%i ms."),dword ptr pcanswr
;    mov eax,TestNum
;    add eax,5000	; id of result box for this test
;    inv SetDlgItemText,hWin,eax,addr buff

	fld pcreal
    inv FpuFLtoA,0,1,addr buff,SRC1_FPU or SRC2_DIMM
    mov eax,TestNum
    add eax,5000	; id of result box for this test
    inv SetDlgItemText,hWin,eax,addr buff

	mov eax,TestNum
	add eax,4000
	mov edx,dword ptr counts
	inv SetDlgItemInt,hWin,eax,edx,0

endm


msg Macro qtext:VARARG
local result
pusha
    quote SUBSTR <qtext>,1,1
    IFIDN quote , <">  ;; if this is a quoted string
        invoke MessageBox,0,soff(qtext),0,0
    else
        result=opattr(qtext)
        if result eq 48 ;; a register
            invoke MessageBox,0,qtext,0,0
        else
            invoke MessageBox,0,addr qtext,0,0
        endif
    endif   
popa
endm

prtd MACRO argf	; debugging print
pusha
mov edx,argf
inv dwtoa,edx,addr dwtoabuf
invoke MessageBox,0,addr dwtoabuf,0,0
popa
EndM

GetHandle Macro MyId:Req,MyHandle:Req 
    invoke GetDlgItem,hWin,MyId
    mov MyHandle,eax         ; save handle to control
endm

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib gdi32

;uselib shell32
;uselib comdlg32
uselib masm32
;uselib debug
uselib oleaut32

uselib fpu
.listall

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD

;scratch for tests
.data?
align 4
temp1   dd ?    ; aligned
temp2   dd ?
buff db 100 dup (?)
dwtoabuf db 12 dup (?)
align 8
count2 dq ?
.code
start:
    invoke  InitCommonControls
    invoke  GetModuleHandle, NULL
    invoke  DialogBoxParam, eax, 101, 0, ADDR DlgProc, 0
    invoke  ExitProcess, eax

