TimesToLoop equ 1;00;00;00;0 ; number of times to loop
include Part1.inc
; -------------------------------------  Timing Tests -----------------------------------

; This is the code to copy to create new timing tests. Copy this code and paste it below.
; Change the X in DoitX to a number (Doit1, Doit2,...Doit99)
DoitX:
    Desc ' ' ;insert description of this test between single quotes
    ; -- place any setup desired here.  Registers will not be preserved into test code --
    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------

    EndCounter      ; end of test code --------------------------------------------------
    ret

;--------------------------------- Test Procs -------------------------------------------

;  Place any test procs or setup/checking procs you wish here
align 16
nrQsortAx proc Arr:DWORD,count:DWORD  ; stock masmlib

    LOCAL First :DWORD
    LOCAL Last  :DWORD
    LOCAL cntr  :DWORD
    LOCAL bLen  :DWORD
    LOCAL hMem  :DWORD
    LOCAL temp  :DWORD

    push ebx
    push esi
    push edi

    mov esi, Arr              ; source address in ESI

    mov cntr, 0

  ; --------------------------
  ; allocate temporary buffer
  ; --------------------------
    mov eax, count
    add eax, 40
    mov bLen, eax
    invoke SysAllocStringByteLen,0,bLen
    mov hMem, eax

    mov edi, hMem             ; buffer address in EDI

  ; ------------------------------------
  ; set First and Last reference values
  ; ------------------------------------
    mov First, 0
    mov eax, count
    dec eax
    mov Last, eax             ; Last = count - 1

  outer_loop:
  ; -------------------
  ; calculate midpoint
  ; -------------------
    mov eax, Last
    add eax, First
    shr eax, 1
  ; =========================
    mov ebx, [esi+eax*4]      ; midpoint in EBX
    mov temp, ebx
  ; =========================
    mov ecx, First
    mov edx, Last
  ; ---------------------------------------------------------
  inner_loop:
    cmp [esi+ecx*4], ebx
    jge wl2
    inc ecx
    jmp inner_loop
  wl2:
    cmp [esi+edx*4], ebx
    jle wl2Out
    dec edx
    jmp wl2
  wl2Out:
    cmp ecx, edx              ; If ecx > edx, exit inner loop
    jg exit_innerx
  ; =========================
    mov eax, [esi+ecx*4]
    mov ebx, [esi+edx*4]      ; swap elements
    mov [esi+ecx*4], ebx
    mov [esi+edx*4], eax
  ; =========================
    mov ebx, temp             ; restore EBX
    inc ecx
    dec edx
    cmp ecx, edx
    jle inner_loop
  exit_innerx:
  ; ---------------------------------------------------------
    cmp ecx, Last             ; If ecx < Last jump over
    jg iNxt
  ; =========================
    mov eax, cntr
    mov [edi+eax*4], ecx
    mov ebx, Last
    mov [edi+eax*4+4], ebx
  ; =========================
    add cntr, 2
  iNxt:
    mov ebx, temp             ; restore EBX
    mov Last, edx             ; Last  = EDX
    cmp edx, First            ; compare Last & First
    jg outer_loop

    cmp cntr, 0
    jz qsOut
    sub cntr, 2
  ; =========================
    mov eax, cntr
    mov ebx, [edi+eax*4]
    mov First, ebx
    mov ebx, [edi+eax*4+4]
    mov Last, ebx
  ; =========================
    mov ebx, temp             ; restore EBX
    jmp outer_loop

    qsOut:

    invoke SysFreeString,hMem

    pop edi
    pop esi
    pop ebx

    ret

nrQsortAx endp

align 16
nrQsortAx4 proc Arr:DWORD,count:DWORD
    LOCAL First,Last,cntr,bLen,hMem,temp
    ;note: this first section can be smaller, but need to kill
    ;      some bytes to get good 16 byte alignment at MainLoop anyway
    push ebx
    push esi
    push edi
    mov esi,Arr    ; source address kept in esi througout
    mov cntr,0	   ; pointer into heap

 	;inv GetProcessHeap	; for testing, will always be known
	;mov hHeap,eax
    mov eax,count		; allocate temporary buffer
    add eax,40
    mov bLen,eax
    invoke SysAllocStringByteLen,0,eax
	;inv HeapAlloc,hHeap,0,eax	; better if you already have the heap handle
    mov hMem,eax
    mov edi,eax ; hMem  ; keep buffer address in edi thoroughout
    mov First,0	      	; set First and Last reference values
    mov eax,count
    sub eax,1
    mov Last,eax   		; Last, when zero based array
    
	align 16
MainLoop:
    mov edx,Last
MainLoop2:				; second entry into Main loop
    mov ecx,First
MainLoop3:
    mov eax,ecx		     ; calculate midpoint
    add eax,edx
    shr eax,1		     ; \2  cannot be combined with *4 in next instruction
    mov ebx,[esi+eax*4] ; value at midpoint kept in ebx throughout
    mov temp,ebx
	dec ecx			; setup for tight loop
	.repeat
  		inc ecx		; look for value greater than midpoint on left side of group
InnerLoop2:
	.until sdword ptr [esi+ecx*4]>=ebx	; else will match at midpoint and fall out
  	inc edx			; found one, or midpoint itself
	.repeat
  		dec edx	; look for value less than midpoint on right side
  	.until sdword ptr [esi+edx*4]<=ebx	; will match at midpoint and fall out
    .if ecx<=edx
	    mov eax,[esi+ecx*4]
	    mov ebx,[esi+edx*4]		; swap elements
	    mov [esi+ecx*4], ebx
	    mov [esi+edx*4], eax
	
	    mov ebx,temp            ; restore midpoint
	    inc ecx
	    dec edx
	    cmp ecx,edx
	    jle InnerLoop2			; go back and look for more values to move
	.endif

  	.if sdword ptr ecx<Last  ; changed from <= to <
    	mov eax, cntr
    	mov [edi+eax*4], ecx
    	mov ebx, Last
    	mov [edi+eax*4+4], ebx
    	add cntr, 2
    .endif
    mov Last, edx             ; new Last point
    cmp edx, First            ; compare Last & First
    jg MainLoop2
    
    mov eax,cntr
    .if eax!=0		; are we done?
	    sub eax,2	; no, get previous First and Last
	    mov cntr,eax
	    mov ecx, [edi+eax*4]
	    mov First, ecx
	    mov edx, [edi+eax*4+4]
	    mov Last, edx
	    jmp MainLoop3
	.endif

    invoke SysFreeString,hMem
    ;inv HeapFree,hHeap,0,hMem

    pop edi
    pop esi
    pop ebx

    ret

nrQsortAx4 endp

;---------------------------- setup routine -------------------------  
.data
randsize = 1000000 ;1000000
rheap dd 0
.code
GetHeap:
	.if rheap==0
	inv GetProcessHeap
	mov hHeap,eax
		inv HeapAlloc,hHeap,0,randsize*4
		mov rheap,eax
	.endif
	ret
GenRand:
	pusha
	call GetHeap
	inv nseed,012345678
	mov esi,randsize
	mov edi,rheap
	.repeat
		inv nrandom,80000000h-1
		.if eax>40000000h
			neg eax
		.endif
		mov [edi],eax
		add edi,4
		dec esi
	.until zero?
	;call ShowRan
	popa
	ret
GenSorted:
	pusha
	call GetHeap
	mov esi,0
	mov edi,rheap
	mov eax,randsize
	shr eax,1
	neg eax		; from -randsize/2 to randsize/2
	.repeat
		mov [edi+esi*4],eax
		inc eax
		inc esi
	.until esi==randsize
	call CheckAnswer
	popa
	ret
GenReversed:
	pusha
	call GetHeap
	mov esi,0
	mov edi,rheap
	mov eax,randsize
	shr eax,1	; from randsize/2 to -randsize/2
	.repeat
		mov [edi+esi*4],eax
		dec eax
		inc esi
	.until esi==randsize
	popa
	ret
GenConstant:
	pusha
	call GetHeap
	mov esi,0
	mov edi,rheap
	mov eax,9999
	.repeat
		mov [edi+esi*4],eax
		inc esi
	.until esi==randsize
	popa
	ret

GenAlternating:
	pusha
	call GetHeap
	mov esi,0
	mov edi,rheap
	mov eax,randsize
	shr eax,1
	;neg eax		; from -randsize/2 to randsize/2
	.repeat
		mov [edi+esi*4],eax
		inc esi
		neg eax		; alternate high and low values
		mov [edi+esi*4],eax
		neg eax		; restore for next store
		dec eax
		inc esi
	.until esi>=randsize	; don't use an odd number of values
	popa
	ret
GenCyclic:
	pusha
	call GetHeap
	mov esi,0
	mov edi,rheap
	mov eax,1
	.repeat
		mov [edi+esi*4],eax
		inc eax
		.if eax==17	; generate 0-17 repeatedly
			mov eax,0
		.endif
		inc esi
	.until esi==randsize
	popa
	ret
GenTapering:
	pusha
	call GetHeap
	mov esi,0
	mov edi,rheap
	mov eax,randsize	; will count down from both ends toward middle
	mov ecx,randsize	; e.g. 10 8 6 4 2 0 1 3 5 7 9
	sub ecx,1
	mov edx,randsize
	;shr edx,1			; half
	.repeat
		mov [edi+esi*4],eax
		dec eax
		mov [edi+ecx*4],eax
		dec eax
		inc esi
		dec ecx
		sub edx,2	; count
	.until sign?
	popa
	ret
	

CheckAnswer:
	pusha
	mov esi,rheap
	mov ecx,1
	.repeat
		mov eax,[esi+ecx*4-4]
		mov edx,[esi+ecx*4]
		.if sdword ptr eax>edx
			msg "error in sort at element"
			prtd ecx
			prtd eax
			prtd edx
			jmp cawrap
		.endif
		inc ecx
	.until ecx==randsize
cawrap:
	popa
	ret
ShowRan:
	pusha
	mov esi,rheap
	mov edi,0
	.repeat
		lodsd
		prtd eax
		inc edi
	.until edi==3
	popa
	ret
compprcnt:
	pusha
	mov esi,TestNum
	add esi,4000	; get id of box containing counts of test
	mov edi,esi
	dec edi			; get id of counts of test one line above
	inv GetDlgItemInt,hWin,edi,0,0
	mov edi,eax	; save
	inv GetDlgItemInt,hWin,esi,0,0
	sub eax,edi
	mov tmp,eax	; save answer
	mov tmp3,edi
	fild tmp
	fild tmp3
	fdiv
	fild t100
	fmul
	inv FpuFLtoA,0,2,addr buff,SRC1_FPU or SRC2_DIMM
	add esi,2000	; point at last box
    mov edi,offset buff
    mov ecx,100
    xor eax,eax
    repne scasb
    mov eax,'%'
    mov	[edi-1],eax
    inv SetDlgItemText,hWin,esi,addr buff
	popa
	ret
;------------------------------------------------------------------------------------
;nrQsortAx nrQsortAx3 nrQsortAx4
BaseRoutine = nrQsortAx
TestRoutine = nrQsortAx4

;------------------------------------------------------------------------------------
	
;Doit1:       ;---------------------------------------------------------------------------
;    Desc 'calling from masmlib' ;insert description of this test between single quotes
;    ; -- place any setup desired here.  Registers will not be preserved into test code --
;	call GenRand
;    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------
;		inv CombSortA,rheap,randsize
;    EndCounter  ; end of test code ------------------------------------------------------
;	call CheckAnswer
;	; to print out an anwser-
;    ; inv SetDlgItemInt,hWin,6001,Val,0
;    ret

Doit2:       ;---------------------------------------------------------------------------
    Desc 'masmlib code inline Random'
	call GenRand
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit3:       ;---------------------------------------------------------------------------
    Desc 'TestRoutine Random'
	call GenRand
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret
Doit4:       ;---------------------------------------------------------------------------
    Desc 'masmlib presorted'
	call GenSorted
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit5:       ;---------------------------------------------------------------------------
    Desc 'TestRoutine presorted'
	call GenSorted
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret
Doit6:       ;---------------------------------------------------------------------------
    Desc 'masmlib reversed'
	call GenReversed
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit7:       ;---------------------------------------------------------------------------
    Desc 'TestRoutine reversed'
	call GenReversed
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret
Doit8:       ;---------------------------------------------------------------------------
    Desc 'masmlib constant data'
	call GenConstant
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit9:       ;---------------------------------------------------------------------------
    Desc 'TestRoutine constant data '
	call GenConstant
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret

Doit10:      ;---------------------------------------------------------------------------
    Desc 'masmlib alternating data'
	call GenAlternating
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit11:      ;---------------------------------------------------------------------------
    Desc 'TestRoutine alternating data '
	call GenAlternating
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret

Doit12:      ;---------------------------------------------------------------------------
    Desc 'masmlib cycling data'
	call GenCyclic
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit13:      ;---------------------------------------------------------------------------
    Desc 'TestRoutine cycling data '
	call GenCyclic
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret

Doit14:      ;---------------------------------------------------------------------------
    Desc 'masmlib Tapering data (do not run large sample!)'
	call GenTapering
    BeginCounter
		inv BaseRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
    ret

Doit15:      ;---------------------------------------------------------------------------
    Desc 'TestRoutine Tapering data (do not run large sample!)'
	call GenTapering
    BeginCounter
		inv TestRoutine,rheap,randsize
    EndCounter
	call CheckAnswer
	call compprcnt
    ret

;Doit14:       ;---------------------------------------------------------------------------
;	call GenTapering
;    Desc ' '
;    BeginCounter
;    EndCounter
;	call CheckAnswer
;    ret

;               ------------------------ end of timing tests --------------------
include Part2.inc